const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const employeeStatusService = require('./employeeStatus.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new employeeStatus
 * @param {Object} req.body - The employeeStatus data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created employeeStatus
 */
function create(req, res, next) {
    employeeStatusService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all employeeStatuss
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeStatuss
 */
function getAll(req, res, next) {
    employeeStatusService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of employeeStatus objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeStatus objects
 */
function option(req, res, next) {
    employeeStatusService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of employeeStatuss matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of employeeStatuss
 */
function count(req, res, next) {
    employeeStatusService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing employeeStatus
 * @param {number} req.params.id - The employeeStatus ID to be updated
 * @param {Object} req.body - The employeeStatus data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated employeeStatus
 */
function update(req, res, next) {
    employeeStatusService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a employeeStatus
 * @param {number} req.params.id - The employeeStatus ID to be enabled/disabled
 * @param {Object} req.body - The employeeStatus data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the employeeStatus
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    employeeStatusService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a employeeStatus
 * @param {number} req.params.id - The employeeStatus ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    employeeStatusService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
